/*
 * New editor name:  tde, the Thomson-Davis Editor.
 * Author:           Frank Davis
 * Date:             June 5, 1991
 *
 * This modification of Douglas Thomson's code is released into the
 * public domain, Frank Davis.  You may distribute it freely.
 *
 * This file defines all functions in editor.
 */

#define   Help                     1
#define   Rturn                    2
#define   NextLine                 3
#define   BegNextLine              4
#define   LineDown                 5
#define   LineUp                   6
#define   CharRight                7
#define   CharLeft                 8
#define   ScrollRight              9
#define   ScrollLeft              10
#define   WordRight               11
#define   WordLeft                12
#define   ScreenDown              13
#define   ScreenUp                14
#define   EndOfFile               15
#define   TopOfFile               16
#define   BotOfScreen             17
#define   TopOfScreen             18
#define   EndOfLine               19
#define   BegOfLine               20
#define   JumpToLine              21
#define   CenterWindow            22
#define   CenterLine              23
#define   HorizontalScreenRight   24
#define   HorizontalScreenLeft    25
#define   ScrollDnLine            26
#define   ScrollUpLine            27
#define   FixedScrollUp           28
#define   FixedScrollDn           29
#define   ToggleOverWrite         30
#define   ToggleSmartTabs         31
#define   ToggleIndent            32
#define   ToggleWordWrap          33
#define   ToggleCRLF              34
#define   ToggleTrailing          35
#define   ToggleZ                 36
#define   ToggleEol               37
#define   ToggleSync              38
#define   ToggleRuler             39
#define   SetTabs                 40
#define   SetLeftMargin           41
#define   SetRightMargin          42
#define   SetParagraphMargin      43
#define   FormatParagraph         44
#define   FormatText              45
#define   LeftJustify             46
#define   RightJustify            47
#define   CenterJustify           48
#define   Tab                     49
#define   BackTab                 50
#define   ParenBalance            51
#define   BackSpace               52
#define   DeleteChar              53
#define   StreamDeleteChar        54
#define   DeleteLine              55
#define   DelEndOfLine            56
#define   WordDelete              57
#define   AddLine                 58
#define   SplitLine               59
#define   JoinLine                60
#define   DuplicateLine           61
#define   AbortCommand            62
#define   UndoLine                63
#define   UndoDelete              64
#define   ToggleSearchCase        65
#define   FindForward             66
#define   FindBackward            67
#define   RepeatFindForward1      68
#define   RepeatFindForward2      69
#define   RepeatFindBackward1     70
#define   RepeatFindBackward2     71
#define   ReplaceForward          72
#define   ReplaceBackward         73
#define   MarkBox                 74
#define   MarkLine                75
#define   MarkStream              76
#define   UnMarkBlock             77
#define   FillBlock               78
#define   NumberBlock             79
#define   CopyBlock               80
#define   KopyBlock               81
#define   MoveBlock               82
#define   OverlayBlock            83
#define   DeleteBlock             84
#define   BlockToFile             85
#define   PrintBlock              86
#define   BlockExpandTabs         87
#define   BlockTrimTrailing       88
#define   BlockUpperCase          89
#define   BlockLowerCase          90
#define   BlockStripHiBit         91
#define   SortBoxBlock            92
#define   DateTimeStamp           93
#define   EditFile                94
#define   DirList                 95
#define   File                    96
#define   Save                    97
#define   SaveAs                  98
#define   SetFileAttributes       99
#define   EditNextFile           100
#define   RedrawScreen           101
#define   SizeWindow             102
#define   SplitHorizontal        103
#define   SplitVertical          104
#define   NextWindow             105
#define   PreviousWindow         106
#define   ZoomWindow             107
#define   NextHiddenWindow       108
#define   SetMark1               109
#define   SetMark2               110
#define   SetMark3               111
#define   GotoMark1              112
#define   GotoMark2              113
#define   GotoMark3              114
#define   RecordMacro            115
#define   PlayBack               116
#define   SaveMacro              117
#define   LoadMacro              118
#define   ClearAllMacros         119
#define   Pause                  120
#define   Quit                   121

#define   TwoCharKey            0x80

#define   WordWrap               125
/*
 *  These are not functions.  They redefine the Control code sequence.
 */

#define     CNTRL_A             431
#define     CNTRL_B             432
#define     CNTRL_C             433
#define     CNTRL_D             434
#define     CNTRL_E             435
#define     CNTRL_F             436
#define     CNTRL_G             437
#define     CNTRL_H             438
#define     CNTRL_I             439
#define     CNTRL_J             440
#define     CNTRL_K             441
#define     CNTRL_L             442
#define     CNTRL_M             443
#define     CNTRL_N             444
#define     CNTRL_O             445
#define     CNTRL_P             446
#define     CNTRL_Q             447
#define     CNTRL_R             448
#define     CNTRL_S             449
#define     CNTRL_T             450
#define     CNTRL_U             451
#define     CNTRL_V             452
#define     CNTRL_W             453
#define     CNTRL_X             454
#define     CNTRL_Y             455
#define     CNTRL_Z             456
