* WORDPERF.PRG - convert to WP merge files
* Creates a WordPerfect compatible Secondary Merge file
* Complete with field name headers to enable use of Field names in documents.
* Rick Shaddock, Computer Programming Company
* 202-829-4444

* Directions:
*    1.  USE the database you would like to export.
*    2.  SET FILTER TO, if you would like to apply a condition
*    3.  SET FIELDS TO, if you would like to specify a field list
*    4.  DO WORDPERF, and let it work.

set talk off
public FOX
if FOX
 FILE =alias()+'.WP'
else
 FILE =substr(dbf(),1,at('.',dbf())-1)
endif
release FOX
FILE =upper(FILE) +space(13-len(trim(FILE)))
@ row(),0 say 'WordPerfect File to create: ' get FILE picture '@!'
?
vVERSION ='5.1'
@ row(),0 say 'Version (4.2 - 5.1): WordPerfect' get vVERSION pict '9.9'
read
FILE =ltrim(trim(FILE))
if len(FILE) =0  .or. FILE ='.'
 return
endif
set alternate to &FILE

select 9  && STRUCTURE
use

select 1  && DBF
? Dbf()
set safety off
 copy structure extended to DB_STRU
set safety on

if val(vVERSION) >= 5
 * Create Fields Names
 select 9
 use DB_STRU
 set alternate on
  * ^N [HRt]
  ?? chr(14) +chr(13) +chr(10)
 set alternate off
 do while .not. eof()
  * List each field name enclosed in Bold codes
  set alternate on
   * [BOLD] FIELD_NAME [bold] +J    YenSign FIELD_NAME BritishPound + Chr(10)
   ?? chr(157) +trim(FIELD_NAME) +chr(156) +chr(10)
  set alternate off
  skip
 enddo
 set alternate on
  * ^R
  ?? chr(18) +chr(10)
 set alternate off
 go top
 skip
 do while .not. eof()
  * Insert extra ^N^R 's at end for some reason
  set alternate on
   * ^N^R [HRt]  - enough for the remaining fields
   ?? chr(14) +chr(18) +chr(10)
  set alternate off
  skip
 enddo
 set alternate on
  * ^E {ENDRECORD} + [HPg]
  ?? chr(5) +chr(12)
 set alternate off
endif

select 1  && DBF
go top
do while .not. eof()
 clear
 set color to W*/R
 @ 1, 20 say 'Preparing WordPerfect Merge File'
 set color to W+/B
 @ 0, 18 to 2, 53 double
 @ 4,0 clear
 select 9  && STRUCTURE
 go top
 do while .not. Eof()
  FIELD=FIELD_NAME
  FTYPE=FIELD_TYPE
  LENGTH=FIELD_LEN
  DEC=FIELD_DEC

  select 1
  do case
  case FTYPE='C'
   vCONTENTS =trim(&FIELD)
  case FTYPE='N'
   vCONTENTS =str(&FIELD,LENGTH,DEC)
  case FTYPE='D'
   vCONTENTS =dtoc(&FIELD)
  case FTYPE='L'
   if &FIELD
    vCONTENTS ='T'
   else
    vCONTENTS ='F'
   endif
  case FTYPE='M'
   vCONTENTS ='MEMO'
  otherwise
   wait 'A problem'
  endcase
  set alternate on
   * ^R {ENDFIELD} [HRt]
   do case
   case vVERSION ='4.2' .or. vVERSION ='5.0'
    ?? trim(vCONTENTS) +chr(18) +' '
   case vVERSION ='5.1'
    ?? trim(vCONTENTS) +chr(18) 
   endcase
  set alternate off

  select 9
  skip
 enddo

 select 1
 set alternate on
  * ^E {ENDRECORD} + [HPg]
  ?? chr(5) +chr(12)
 set alternate off
 skip
enddo
select 9  && STRUCTURE
use
select 1
erase DB_STRU.DBF

close alternate
?? chr(7)
? 'Done'
**
